﻿Public Class FImpresion_VB_Word

    Private Sub FImpresion_VB_Word_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Iniciar el DGV para probar

        DGVProba.Columns.Add("Cantidad", "Cantidad")
        DGVProba.Columns.Add("Referencia", "Referencia")
        DGVProba.Columns.Add("Producto", "Producto")
        DGVProba.Columns.Add("Precio", "Precio")
        DGVProba.Rows.Add("2", "Ref.012", "Azerty", "12.5")
        DGVProba.Rows.Add("5", "Ref.015", "Qwerty", "15.0")
        DGVProba.Rows.Add("1", "Ref.011", "Panzani", "21.5")
        DGVProba.Rows.Add("3", "Ref.013", "Macaroni", "25.5")

    End Sub


#Region "Impresion"

    Dim ArchivoPrimeroParaImpresion As String = CurDir() & "\DocPrimero.docx"

    Private Sub BImprimir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BImprimir.Click

        GoToWord()

    End Sub

    Private Sub GoToWord()
        Dim WAPP As New Microsoft.Office.Interop.Word.Application
        Dim UnDoc As New Microsoft.Office.Interop.Word.Document
        Dim Table As Microsoft.Office.Interop.Word.Table

        ' Trabajar con  un duplicado (FImpresion) del archivo para no cambiar el original
        Dim Punto As Integer
        Punto = ArchivoPrimeroParaImpresion.LastIndexOf(".")
        Dim FImpresion As String = ArchivoPrimeroParaImpresion.Substring(0, Punto) & "_" & Trim(Now.Millisecond) & ".Docx"
        System.IO.File.Copy(ArchivoPrimeroParaImpresion, FImpresion)

        ' Abrir el archivo FImpresion y tratar
        UnDoc = WAPP.Documents.Open(FImpresion)
        WAPP.Visible = True

        ' ***  Llenar el documento (ejemplos)

        Table = UnDoc.Tables(1)  ' Las tablas son indiciado de 1 a N, si N tablas
        ' En una tabla, los datos son indicado por sus lineas y columnas :
        ' Table.Cell(Linea, Columna).Range.Text = ...     ' Linea de 1 a N lineas y Columna de 1 a N columnas
        ' Si una sola celda, este es linea 1 y columna 1
        Table.Cell(1, 1).Range.Text = "TITULO del " & Now.ToShortDateString

        ' Un Bookmarks es designado por su nombre
        UnDoc.Bookmarks("MiBookMarks01").Range.Text = "El marca no es hecho para esta, mejor son los campos de fusión y las tablas"

        ' Los campos de fusion son indiciado de 1 à N, si N campos 
        For F As Integer = 1 To UnDoc.Fields.Count
            UnDoc.Fields(F).Result.Text = "Texto para MiCampos" & String.Format("{0:00}", F)
        Next

        Table = UnDoc.Tables(2)

        ' Escribir y formatear (mejor es de bien preparar el documento inicial) los titulos de las columnas

        For C As Integer = 0 To DGVProba.ColumnCount - 1
            Table.Cell(1, C + 1).Range.Text = DGVProba.Columns(C).HeaderText
            Table.Cell(1, C + 1).Range.Bold = True
        Next

        ' Escribir las lineas de la tabla
        For R As Integer = 0 To DGVProba.RowCount - 2
            For C As Integer = 0 To DGVProba.ColumnCount - 1
                Table.Cell(R + 2, C + 1).Range.Text = DGVProba.Item(C, R).Value.ToString
            Next
            If R < DGVProba.RowCount - 2 Then
                Table.Rows.Add()
            End If
        Next

        Table = UnDoc.Tables(3)

        ' este es el mismo trabajar para la ultima tabla, pero menos una columna

        For C As Integer = 1 To DGVProba.ColumnCount - 1  ' Sin Cuantidad
            Table.Cell(1, C).Range.Text = DGVProba.Columns(C).HeaderText  ' Atencion a el indicio de la columna
            Table.Cell(1, C).Range.Italic = True
        Next

        ' Escribir las lineas de la tabla
        For R As Integer = 0 To DGVProba.RowCount - 2
            For C As Integer = 1 To DGVProba.ColumnCount - 1 ' Sin Cuantidad
                Table.Cell(R + 2, C).Range.Text = DGVProba.Item(C, R).Value.ToString  ' Atencion a el indicio de la columna
            Next
            If R < DGVProba.RowCount - 2 Then
                Table.Rows.Add()
            End If
        Next

        ' Con el Preview, es posible modificar un detalle y eligar la impresora
        WAPP.PrintPreview = True
        WAPP.ShowMe()
    End Sub
#End Region


    ''***'''  ATENCION 

    ' Este es posible de escribir los parrafos :
    ' UnDoc.Content.Paragraphs(1).Range.Text = "Blabla ..." & VbCr

    ' No es posible bien trabajar con Fields en cadro de texto

    ' Este es posible de trabajar con BookMarks en zona de texto, pero no podemos poner la zona de texto en un parrafo.

    ' Pero un Bookmarks no es hecho para esta, este es un HyperLink
    ' Este es mejor de trabajar son los campos de fusión y las tablas

End Class

